using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.VisualBasic.ApplicationServices;
using System.Collections.ObjectModel;
using System.Drawing;

namespace SingleInstance
{
    class SingleInstanceApplication : WindowsFormsApplicationBase
    {
        public SingleInstanceApplication()
        {
            this.IsSingleInstance = true;
        }

        event EventHandler NewInstance;

        protected override void OnCreateMainForm()
        {
            this.MainForm = new MainForm();
            NewInstance += new EventHandler(((MainForm)MainForm).NewInstance);
        }

        
        protected override void OnStartupNextInstance(StartupNextInstanceEventArgs eventArgs)
        {
            ReadOnlyCollection<String> args = eventArgs.CommandLine;
            if (args.Count > 1)
            {
                try
                {
                    if (NewInstance != null) NewInstance(new Point(int.Parse(args[0]), int.Parse(args[1])), null);
                }
                catch (FormatException)
                {

                }
            }
        }

        static SingleInstanceApplication application;
        internal static SingleInstanceApplication Application
        {
            get
            {
                if (application == null)
                {
                    application = new SingleInstanceApplication();
                }
                return application;
            }
        }
    }
}
